SystemOrganization addCategory: #'PEGWiki-Resources'!

!ALHtmlResource methodsFor: '*pegwiki-resources' stamp: 'chc 1/4/2016 10:39'!
renderOnStream: out locator: aLocator
	| context |
	context := ALRenderingContext resource: self locator: aLocator.
	^ component renderOn: (ALAppHtml5Canvas context: context stream: out)! !

!ALResponse class methodsFor: '*pegwiki-resources' stamp: 'chc 1/27/2015 15:08'!
unauthorized
	^ self status: 401 reason: 'Unauthorized' details: 'You have not logged in'! !

ALTextareaTag subclass: #PWAppTextareaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Resources'!

!PWAppTextareaTag methodsFor: 'accessing' stamp: 'chc 1/7/2016 18:39'!
callback: aValuable
	self name: (canvas currentForm registerCallback: aValuable) asString
! !

!PWAppTextareaTag methodsFor: 'accessing' stamp: 'chc 1/7/2016 18:39'!
send: aSelector to: anObject
	self value: (anObject perform: aSelector).
	self callback: [:v | anObject perform: aSelector asMutator with: v]! !

!ALAppHtml5Canvas methodsFor: '*pegwiki-resources' stamp: 'chc 1/7/2016 18:42'!
textarea
	^ self open: (PWAppTextareaTag on: self)
! !

ALComponentResource subclass: #PWBasicAuthResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Resources'!

!PWBasicAuthResource commentStamp: 'chc 3/22/2016 09:30' prior: 0!
Drops down browser window for username and password.!

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 6/23/2015 16:39'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	^ (ALResponse seeOther: url)
			setCookie: cookie; 
			yourself! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:08'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:46'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:15'!
respondWithChallenge
	^ALResponse unauthorized
		wwwAuthenticate: 'Basic Realm = "My Server"';
			yourself! !

Object subclass: #PWFormatRequest
	instanceVariableNames: 'wikiString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Resources'!

!PWFormatRequest commentStamp: 'chc 3/22/2016 09:38' prior: 0!
This category is for tags, resources and HTTP changes!

!PWFormatRequest class methodsFor: 'as yet unclassified' stamp: 'chc 8/18/2015 13:41'!
username: username password: password
	^ (self withUsername: username password: password) signal! !

!PWFormatRequest class methodsFor: 'as yet unclassified' stamp: 'chc 8/18/2015 13:41'!
withUsername: username password: password
	^ self basicNew
		initializeWithUsername: username password: password! !

!PWFormatRequest methodsFor: 'initialization' stamp: 'chc 8/18/2015 13:42'!
initializeWithUsername: aUsername password: aPassword
	self initialize.
	! !

!PWFormatRequest methodsFor: 'interpreting' stamp: 'chc 8/18/2015 13:53'!
name: aString value: anObject
	aString = 'wikiString' ifTrue: [wikiString := anObject].
	! !

!PWFormatRequest methodsFor: 'interpreting' stamp: 'chc 8/18/2015 13:41'!
object: aBlock
	aBlock value
	! !

!PWFormatRequest methodsFor: 'accessing' stamp: 'chc 8/18/2015 13:42'!
wikiString

	^ wikiString! !

!PWFormatRequest methodsFor: 'accessing' stamp: 'chc 8/18/2015 13:42'!
wikiString: anObject

	wikiString := anObject! !

!ALJsonResource methodsFor: '*pegwiki-resources' stamp: 'chc 3/29/2016 09:57'!
handlePost: aRequest locator: aLocator
	| request wikiString wikiGrammar parser html |
	request := PWFormatRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	"put new wiki string in the class var"
	wikiString := (request wikiString) withSqueakLineEndings.
	PWSeasidePrefsModel instance takeValue: wikiString forAttribute: (WAStringAttribute key: #currentString group: #wikidata).
	"make string to put in component"
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	self component html: html.
	"return response"
	"do I need a redirect so that the GET is activated?"
 	^ ALResponse 
		type: ALContentType json 
		callback: [ :out | self renderOnStream: out locator: aLocator ]

! !

!ALJsonResource methodsFor: '*pegwiki-resources' stamp: 'chc 1/4/2016 10:41'!
renderOnStream: out locator: aLocator
	| context |
	context := ALRenderingContext resource: self locator: aLocator.
	^ self component renderOn: (ALJsonRenderer context: context stream: out)! !
